org.apache.commons.math3.transform

## Enum DctNormalization

- java.lang.Object
- - java.lang.Enum<DctNormalization>
  - - org.apache.commons.math3.transform.DctNormalization

All Implemented Interfaces:
  Serializable, Comparable<DctNormalization>

    public enum DctNormalization
    extends Enum<DctNormalization>

This enumeration defines the various types of normalizations that can be applied to discrete cosine transforms (DCT). The exact definition of these normalizations is detailed below.

Since:
  3.0
Version:
  $Id: DctNormalization.java 1385310 2012-09-16 16:32:10Z tn $
See Also:
  `FastCosineTransformer`

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`ORTHOGONAL_DCT_I` Should be passed to the constructor of `FastCosineTransformer` to use the orthogonal normalization convention.
`STANDARD_DCT_I` Should be passed to the constructor of `FastCosineTransformer` to use the standard normalization convention.

### Method Summary

Methods
`static DctNormalization` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static DctNormalization[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### STANDARD_DCT_I

    public static final DctNormalization STANDARD_DCT_I

Should be passed to the constructor of `FastCosineTransformer` to use the standard normalization convention. The standard DCT-I normalization convention is defined as follows

- forward transform: yn = (1/2) [x0 + (-1)nxN-1] + ∑k=1N-2 xk cos[π nk / (N - 1)],
- inverse transform: xk = [1 / (N - 1)] [y0 + (-1)kyN-1] + [2 / (N - 1)] ∑n=1N-2 yn cos[π nk / (N - 1)],

where N is the size of the data sample.

#### ORTHOGONAL_DCT_I

    public static final DctNormalization ORTHOGONAL_DCT_I

Should be passed to the constructor of `FastCosineTransformer` to use the orthogonal normalization convention. The orthogonal DCT-I normalization convention is defined as follows

- forward transform: yn = [2(N - 1)]-1/2 [x0 + (-1)nxN-1] + [2 / (N - 1)]1/2 ∑k=1N-2 xk cos[π nk / (N - 1)],
- inverse transform: xk = [2(N - 1)]-1/2 [y0 + (-1)kyN-1] + [2 / (N - 1)]1/2 ∑n=1N-2 yn cos[π nk / (N - 1)],

which makes the transform orthogonal. N is the size of the data sample.

### Method Detail

#### values

    public static DctNormalization[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (DctNormalization c : DctNormalization.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static DctNormalization valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null